From 3403ae85002d8e0679da47aa5345a3f6a0790575 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Feb 12 2021 06:34:50 +0000
Subject: [PATCH 2107/2232] Generalize $crate parse to Crate enum


---

diff --git a/macro/src/lib.rs b/macro/src/lib.rs
index b39de52..28c8a1b 100644
--- a/macro/src/lib.rs
+++ b/macro/src/lib.rs
@@ -36,8 +36,8 @@ mod type_id;
 use crate::syntax::file::Module;
 use crate::syntax::namespace::Namespace;
 use crate::syntax::qualified::QualifiedName;
+use crate::type_id::Crate;
 use proc_macro::TokenStream;
-use proc_macro2::TokenTree;
 use syn::parse::{Parse, ParseStream, Parser, Result};
 use syn::parse_macro_input;
 
@@ -77,13 +77,13 @@ pub fn bridge(args: TokenStream, input: TokenStream) -> TokenStream {
 #[proc_macro]
 pub fn type_id(input: TokenStream) -> TokenStream {
     struct TypeId {
-        krate: TokenTree,
+        krate: Crate,
         path: QualifiedName,
     }
 
     impl Parse for TypeId {
         fn parse(input: ParseStream) -> Result<Self> {
-            let krate: TokenTree = input.parse()?;
+            let krate = input.parse().map(Crate::DollarCrate)?;
             let path = QualifiedName::parse_quoted_or_unquoted(input)?;
             Ok(TypeId { krate, path })
         }
diff --git a/macro/src/type_id.rs b/macro/src/type_id.rs
index 5c5d9cc..23df13e 100644
--- a/macro/src/type_id.rs
+++ b/macro/src/type_id.rs
@@ -1,7 +1,12 @@
 use crate::syntax::qualified::QualifiedName;
-use proc_macro2::TokenStream;
+use proc_macro2::{TokenStream, TokenTree};
 use quote::{format_ident, quote};
 
+pub enum Crate {
+    Cxx,
+    DollarCrate(TokenTree),
+}
+
 // "folly::File" => `(f, o, l, l, y, (), F, i, l, e)`
 pub fn expand(arg: QualifiedName) -> TokenStream {
     let mut ids = Vec::new();

